package io.tswf.minecraft.blockventure.core.api.network.packet

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.IReflectiveNBTObject
import io.tswf.minecraft.blockventure.core.api.nbt.NBTObjectMapper
import net.minecraft.nbt.NbtCompound
import net.minecraft.nbt.NbtIo

@CompileStatic
class NBTSerializablePlayNetworkPacket implements IPlayNetworkPacket, IReflectiveNBTObject {

    @Override
    void readFromBytes(DataInputStream data) {
        def compound = NbtIo.readCompressed(data)
        NBTObjectMapper.mapToObject(compound, this.class, this)
    }

    @Override
    void writeToBytes(DataOutputStream data) {
        def compound = (NbtCompound) NBTObjectMapper.mapToNbt(this, this.class)
        NbtIo.writeCompressed(compound, data)
    }
}
