package io.tswf.minecraft.blockventure.core.api.network.packet

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.network.packet.ClientNetworkPlayPacketWrapper
import io.tswf.minecraft.blockventure.core.network.packet.NetworkPlayPacketWrapper
import io.tswf.minecraft.blockventure.core.network.packet.ServerNetworkPlayPacketWrapper
import net.minecraft.client.MinecraftClient
import net.minecraft.server.network.ServerPlayerEntity
import net.minecraft.server.world.ServerWorld

import java.util.function.Predicate

@CompileStatic
class NetworkPlayPacketSender {

    static void sendPacketToServer(IPlayNetworkPacket packet) {
        MinecraftClient.getInstance().getNetworkHandler().sendPacket(new ClientNetworkPlayPacketWrapper(packet))
    }

    static void sendPacketToPlayerClient(IPlayNetworkPacket packet, ServerPlayerEntity addresseePlayer) {
        addresseePlayer.networkHandler.sendPacket(new ServerNetworkPlayPacketWrapper(packet))
    }

    static void sendPacketToAllPlayerClientsInWorld(IPlayNetworkPacket packet, ServerWorld addresseeWorld, Predicate<ServerPlayerEntity> filter = { true }) {
        for (def player : addresseeWorld.players) {
            if (filter.test(player)) {
                sendPacketToPlayerClient(packet, player)
            }
        }
    }
}
