package io.tswf.minecraft.blockventure.core.api.registry

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.world.gen.biome.BiomeEnrichManager
import io.tswf.minecraft.blockventure.core.transmutation.expansion.IRefreshableModifiableBiomeInfo
import net.minecraft.world.biome.Biome

import java.util.concurrent.ConcurrentHashMap

@CompileStatic
class BiomeRegistry {

    static Map<String, Biome> registeredBiomes = new ConcurrentHashMap<>()

    static Biome registerBiome(Biome biome, String id) {
        def refreshableBiomeInfo = (IRefreshableModifiableBiomeInfo) biome.modifiableBiomeInfo()
        refreshableBiomeInfo.refreshable = true

        BiomeEnrichManager.setSingleEnrich(biome, true)

        registeredBiomes[id] = biome
    }

}
