package io.tswf.minecraft.blockventure.core.api.registry

import com.mojang.serialization.Lifecycle
import groovy.transform.CompileStatic
import net.minecraft.registry.MutableRegistry
import net.minecraft.registry.Registry
import net.minecraft.registry.RegistryKey
import net.minecraft.util.Identifier

@CompileStatic
class Register {

    static <T> T register(Registry<T> registry, T objectToRegister, String key) {
        if (registry !instanceof MutableRegistry) {
            throw new IllegalArgumentException("The registry '${registry}' is not a mutable!")
        }

        def mutableRegistry = (MutableRegistry) registry
        def registryKey = RegistryKey.of(registry.getKey(), new Identifier(key))
        mutableRegistry.add(registryKey, objectToRegister, Lifecycle.stable())

        return objectToRegister
    }
}
