package io.tswf.minecraft.blockventure.core.api.registry.lookup

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.transforms.nullsafe.NullSafe
import net.minecraft.registry.Registry
import net.minecraft.registry.RegistryEntryLookup
import net.minecraft.registry.RegistryKey
import net.minecraft.registry.entry.RegistryEntry.Reference
import net.minecraft.registry.entry.RegistryEntryList.Named
import net.minecraft.registry.tag.TagKey

@CompileStatic
class RegsitryWrapperEntryLookup<T> implements RegistryEntryLookup<T> {
    Registry<T> wrappedRegistry

    RegsitryWrapperEntryLookup(@NullSafe Registry<T> wrappedRegistry) {
        this.wrappedRegistry = wrappedRegistry
    }

    Optional<Reference<T>> getOptional(RegistryKey<T> key) {
        return wrappedRegistry.getEntry(key)// 410
    }

    Optional<Named<T>> getOptional(TagKey<T> tag) {
        return wrappedRegistry.getEntryList(tag)
    }
}