package io.tswf.minecraft.blockventure.core.api.world.gen.biome

import groovy.transform.CompileStatic
import groovy.transform.stc.ClosureParams
import groovy.transform.stc.SimpleType
import io.tswf.minecraft.blockventure.core.transmutation.expansion.ISingleEnrichBiome
import io.tswf.minecraft.blockventure.core.world.biome.BiomeEnrichContext
import io.tswf.minecraft.blockventure.core.world.biome.BiomeEnrichService
import io.tswf.minecraft.blockventure.core.world.biome.ClosureDelegateBiomeEnrichProvider
import io.tswf.minecraft.blockventure.core.world.biome.IBiomeEnrichProvider
import net.minecraft.world.biome.Biome

@CompileStatic
class BiomeEnrichManager {

    static void registerEnricher(
            @ClosureParams(
                    value = SimpleType,
                    options = "io.tswf.minecraft.blockventure.core.world.biome.BiomeEnrichContext"
            )
            @DelegatesTo(BiomeEnrichContext)
            Closure biomeEnrichProvider
    ) {
        registerEnrichProvider(new ClosureDelegateBiomeEnrichProvider(biomeEnrichProvider))
    }

    static void registerEnrichProvider(
            IBiomeEnrichProvider biomeEnrichProvider
    ) {
        BiomeEnrichService.biomeEnrichProviders << biomeEnrichProvider
    }

    static void setSingleEnrich(Biome biome, boolean isEnrichSingle) {
        def singleEnrichBiome = (ISingleEnrichBiome) (Object) biome
        singleEnrichBiome.singleEnrich = isEnrichSingle
    }
}