package io.tswf.minecraft.blockventure.core.api.world.gen.feature

import groovy.transform.CompileStatic
import net.minecraft.world.gen.YOffset
import net.minecraft.world.gen.placementmodifier.CountPlacementModifier
import net.minecraft.world.gen.placementmodifier.HeightRangePlacementModifier
import net.minecraft.world.gen.placementmodifier.PlacementModifier
import net.minecraft.world.gen.placementmodifier.SquarePlacementModifier

@CompileStatic
class PlacementModifierFactory {

    static PlacementModifier createHeightRangeModifier(int minHeight, int maxHeight) {
        return HeightRangePlacementModifier.trapezoid(YOffset.fixed(minHeight), YOffset.fixed(maxHeight))
    }

    static PlacementModifier createCountModifier(int count) {
        return CountPlacementModifier.of(count)
    }

    static PlacementModifier createHorizontalRandomOffsetModifier() {
        return SquarePlacementModifier.of()
    }
}
