package io.tswf.minecraft.blockventure.core.block.entity

import groovy.transform.CompileStatic
import groovy.util.logging.Slf4j
import io.tswf.minecraft.blockventure.core.api.block.entity.IAutoTickableBlockEntity
import net.minecraft.block.BlockState
import net.minecraft.block.entity.BlockEntity
import net.minecraft.block.entity.BlockEntityTicker
import net.minecraft.util.math.BlockPos
import net.minecraft.world.World

@Slf4j
@CompileStatic
class AutoBlockEntityTicker implements BlockEntityTicker<BlockEntity> {

    @Override
    void tick(World world, BlockPos pos, BlockState state, BlockEntity blockEntity) {
        if (blockEntity instanceof IAutoTickableBlockEntity) {
            if (blockEntity.isSafeAutoTick()) {
                try {
                    blockEntity.onTick()
                } catch (Throwable e) {
                    log.error("Exception occurred while trying to update tick for block entity ${blockEntity} at ${pos} in world ${world}", e)
                }
            } else {
                blockEntity.onTick()
            }
        }
    }
}
