package io.tswf.minecraft.blockventure.core.block.entity

import groovy.transform.CompileStatic
import groovy.util.logging.Slf4j
import io.tswf.minecraft.blockventure.core.api.registry.Register
import net.minecraft.block.Blocks
import net.minecraft.block.entity.BlockEntityType
import net.minecraft.registry.Registries

@Slf4j
@CompileStatic
class AutoBlockEntityType {

    @Lazy
    static BlockEntityType autoEntityType = BlockEntityType.Builder.create(
            {pos, state -> throw new UnsupportedOperationException("Auto block entity type must be replaced!") },
            Blocks.BEDROCK
    ).build(null)

    static void registerAutoBlockEntityType() {
        log.info("Registering automatic selectable block entity type...")
        Register.register(Registries.BLOCK_ENTITY_TYPE, autoEntityType, "blockventure:auto_select_block_entity")
    }

}
