package io.tswf.minecraft.blockventure.core.exception

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.world.biome.IBiomeEnrichProvider
import net.minecraft.world.biome.Biome

@CompileStatic
class BiomeEnrichException extends RuntimeException {
    Biome biome
    IBiomeEnrichProvider enrichProvider

    BiomeEnrichException(Throwable cause, Biome biome, IBiomeEnrichProvider enrichProvider) {
        super("Exception occurred while trying to enrich ${biome} by ${enrichProvider} with class ${enrichProvider.class.name}", cause)
        this.biome = biome
        this.enrichProvider = enrichProvider
    }
}
