package io.tswf.minecraft.blockventure.core.exception

import groovy.transform.CompileStatic
import net.minecraft.block.entity.BlockEntity

@CompileStatic
class BlockEntityCreationException extends RuntimeException {
    Class<? extends BlockEntity> blockEntityClass

    BlockEntityCreationException(Class<? extends BlockEntity> blockEntityClass) {
        super(getExceptionMessage(blockEntityClass))
        this.blockEntityClass = blockEntityClass
    }

    BlockEntityCreationException(String message, Class<? extends BlockEntity> blockEntityClass) {
        super(getExceptionMessage(blockEntityClass, message))
        this.blockEntityClass = blockEntityClass
    }

    BlockEntityCreationException(String message, Throwable cause, Class<? extends BlockEntity> blockEntityClass) {
        super(getExceptionMessage(blockEntityClass, message), cause)
        this.blockEntityClass = blockEntityClass
    }

    BlockEntityCreationException(Throwable cause, Class<? extends BlockEntity> blockEntityClass) {
        super(getExceptionMessage(blockEntityClass), cause)
        this.blockEntityClass = blockEntityClass
    }

    static String getExceptionMessage(Class blockEntityClass, String message = "") {
        return "Exception occurred while trying to create a new instance of ${blockEntityClass.simpleName}: ${message}"
    }
}
