package io.tswf.minecraft.blockventure.core.exception

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.world.biome.IDimensionBiomesEnrichProvider
import net.minecraft.util.Identifier

@CompileStatic
class DimensionBiomesEnrichException extends RuntimeException {
    Identifier dimensionKey
    IDimensionBiomesEnrichProvider enrichProvider

    DimensionBiomesEnrichException(Throwable cause, Identifier dimensionKey, IDimensionBiomesEnrichProvider enrichProvider) {
        super("Exception occurred while trying to enrich dimension ${dimensionKey} biomes by ${enrichProvider} with class ${enrichProvider.class.name}: ", cause)
        this.dimensionKey = dimensionKey
        this.enrichProvider = enrichProvider
    }
}
