package io.tswf.minecraft.blockventure.core.exception

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.recipe.IRecipeIngredientObjectParseProvider

@CompileStatic
class RecipeIngredientObjectParseException extends RuntimeException {
    Object ingredientObject
    IRecipeIngredientObjectParseProvider parseProvider

    RecipeIngredientObjectParseException(Object ingredientObject, IRecipeIngredientObjectParseProvider parseProvider) {
        super(getExceptionMessage(ingredientObject, parseProvider))
        this.ingredientObject = ingredientObject
        this.parseProvider = parseProvider
    }

    RecipeIngredientObjectParseException(String message, Object ingredientObject, IRecipeIngredientObjectParseProvider parseProvider) {
        super(getExceptionMessage(ingredientObject, parseProvider, message))
        this.ingredientObject = ingredientObject
        this.parseProvider = parseProvider
    }

    RecipeIngredientObjectParseException(String message, Throwable cause, Object ingredientObject, IRecipeIngredientObjectParseProvider parseProvider) {
        super(getExceptionMessage(ingredientObject, parseProvider, message), cause)
        this.ingredientObject = ingredientObject
        this.parseProvider = parseProvider
    }

    RecipeIngredientObjectParseException(Throwable cause, Object ingredientObject, IRecipeIngredientObjectParseProvider parseProvider) {
        super(getExceptionMessage(ingredientObject, parseProvider), cause)
        this.ingredientObject = ingredientObject
        this.parseProvider = parseProvider
    }

    static String getExceptionMessage(Object ingredientObject, IRecipeIngredientObjectParseProvider parseProvider, String message = "") {
        return "Exception occurred while trying to parse ingredient object ${ingredientObject} ${parseProvider == null ? '' : " by ${parseProvider} "}: ${message}"
    }
}
