package io.tswf.minecraft.blockventure.core.groovyextensions

import groovy.transform.CompileStatic
import net.minecraft.registry.entry.RegistryEntry
import net.minecraft.world.biome.GenerationSettings
import net.minecraft.world.gen.GenerationStep.Feature as FeatureGenerationStep
import net.minecraft.world.gen.feature.ConfiguredFeature
import net.minecraft.world.gen.feature.PlacedFeature

@CompileStatic
class AdditionalBiomeGenerationSettingsBuilderMethods {

    static GenerationSettings.Builder feature(GenerationSettings.Builder self, FeatureGenerationStep step, PlacedFeature feature) {
        self.feature(step, new RegistryEntry.Direct<PlacedFeature>(feature))
    }

    static GenerationSettings.Builder feature(GenerationSettings.Builder self, FeatureGenerationStep step, ConfiguredFeature feature) {
        self.feature(step, new RegistryEntry.Direct<PlacedFeature>(new PlacedFeature(new RegistryEntry.Direct<ConfiguredFeature<?,?>>(feature), [])))
    }
}
