package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtByte

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTBooleanMappingProvider extends AbstractNBTDelegateMappingProvider<Boolean, NbtByte> {

    @Override
    void initialize() {
        supportObject Boolean
        supportNbt NbtByte
        fromNbt {
            it.byteValue() > 0
        }
        toNbt {
            NbtByte.of(it)
        }
    }
}
