package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtByte


@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTByteMappingProvider extends AbstractNBTDelegateMappingProvider<Byte, NbtByte> {

    @Override
    void initialize() {
        supportObject Byte
        supportNbt NbtByte
        fromNbt {
            it.byteValue()
        }
        toNbt {
            NbtByte.of(it)
        }
    }
}
