package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtDouble

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTDoubleMappingProvider extends AbstractNBTDelegateMappingProvider<Double, NbtDouble> {

    @Override
    void initialize() {
        supportObject Double
        supportNbt NbtDouble
        fromNbt {
            it.doubleValue()
        }
        toNbt {
            NbtDouble.of(it)
        }
    }
}
