package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtFloat

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTFloatMappingProvider extends AbstractNBTDelegateMappingProvider<Float, NbtFloat> {

    @Override
    void initialize() {
        supportObject Float
        supportNbt NbtFloat
        fromNbt {
            it.floatValue()
        }
        toNbt {
            NbtFloat.of(it)
        }
    }
}
