package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtIntArray

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTIntArrayMappingProvider extends AbstractNBTDelegateMappingProvider<int[], NbtIntArray> {

    @Override
    void initialize() {
        supportObject int[].class
        supportNbt NbtIntArray
        fromNbt {
            it.intArray
        }
        toNbt {
            new NbtIntArray(it)
        }
    }
}
