package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtInt

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTIntegerMappingProvider extends AbstractNBTDelegateMappingProvider<Integer, NbtInt> {

    @Override
    void initialize() {
        supportObject Integer
        supportNbt NbtInt
        fromNbt {
            it.intValue()
        }
        toNbt {
            NbtInt.of(it)
        }
    }
}
