package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.item.ItemStack
import net.minecraft.nbt.NbtCompound

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTItemStackMappingProvider extends AbstractNBTDelegateMappingProvider<ItemStack, NbtCompound> {

    @Override
    void initialize() {
        supportObject ItemStack
        supportNbt NbtCompound
        fromNbt {
            ItemStack.fromNbt(it)
        }
        toNbt { stack ->
            new NbtCompound().let {
                stack.writeNbt(it)
            }
        }
    }
}
