package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtLongArray

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTLongArrayMappingProvider extends AbstractNBTDelegateMappingProvider<long[], NbtLongArray> {

    @Override
    void initialize() {
        supportObject long[].class
        supportNbt NbtLongArray
        fromNbt {
            it.longArray
        }
        toNbt {
            new NbtLongArray(it)
        }
    }
}
