package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtLong

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTLongMappingProvider extends AbstractNBTDelegateMappingProvider<Long, NbtLong> {

    @Override
    void initialize() {
        supportObject Long
        supportNbt NbtLong
        fromNbt {
            it.longValue()
        }
        toNbt {
            NbtLong.of(it)
        }
    }
}
