package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtShort


@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTShortMappingProvider extends AbstractNBTDelegateMappingProvider<Short, NbtShort> {

    @Override
    void initialize() {
        supportObject Short
        supportNbt NbtShort
        fromNbt {
            it.shortValue()
        }
        toNbt {
            NbtShort.of(it)
        }
    }
}
