package io.tswf.minecraft.blockventure.core.nbt.mapper

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.api.nbt.INBTObjectMappingProvider
import net.minecraft.nbt.NbtString

@AutoService(INBTObjectMappingProvider)
@CompileStatic
class NBTStringMappingProvider extends AbstractNBTDelegateMappingProvider<String, NbtString> {

    @Override
    void initialize() {
        supportObject String
        supportNbt NbtString
        fromNbt {
            it.asString()
        }
        toNbt {
            NbtString.of(it)
        }
    }
}
