package io.tswf.minecraft.blockventure.core.recipe.parser

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.recipe.IRecipeIngredientObjectParseProvider
import io.tswf.minecraft.blockventure.core.recipe.RecipeIngredientObjectParser
import net.minecraft.block.Block
import net.minecraft.item.BlockItem
import net.minecraft.recipe.Ingredient

@AutoService(IRecipeIngredientObjectParseProvider)
@CompileStatic
class BlockIngredientObjectParseProvider implements IRecipeIngredientObjectParseProvider {

    @Override
    Ingredient parseIngredientObject(Object ingredientObject) {
        if (ingredientObject instanceof Block) {
            def itemForBlock = BlockItem.BLOCK_ITEMS[ingredientObject]
                    .ensureNotNull { new IllegalStateException("There is no item block for ${ingredientObject}!") }

            return RecipeIngredientObjectParser.parseIngredientObject(itemForBlock)
        }

        return null
    }
}
