package io.tswf.minecraft.blockventure.core.recipe.parser

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.recipe.IRecipeIngredientObjectParseProvider
import io.tswf.minecraft.blockventure.core.recipe.RecipeIngredientObjectParser
import net.minecraft.recipe.Ingredient
import net.minecraftforge.common.crafting.CompoundIngredient

@AutoService(IRecipeIngredientObjectParseProvider)
@CompileStatic
class CollectionIngredientObjectParseProvider implements IRecipeIngredientObjectParseProvider{

    @Override
    Ingredient parseIngredientObject(Object ingredientObject) {
        if (ingredientObject instanceof Collection) {
            if (ingredientObject.isEmpty()) {
                throw new IllegalArgumentException("Empty ingredient collection is not allowed!")
            }
            def compoundParts = ingredientObject
                .map { RecipeIngredientObjectParser.parseIngredientObject(it) }

            return CompoundIngredient.of(compoundParts.toArray { new Ingredient[it] })
        }

        return null
    }
}
