package io.tswf.minecraft.blockventure.core.transmutation.expansion

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.expansion.annotations.Expand
import net.minecraft.block.entity.BlockEntityType

@Expand( targets = @ClassReference(BlockEntityType) )
@CompileStatic
class ExpansionAutoTickerBlockEntityType implements IAutoTickableBlockEntityType{

    boolean autoTicker

    @Override
    boolean isAutoTickerEnabled() {
        return autoTicker
    }

    @Override
    void setAutoTickerEnabled(boolean autoTicker) {
        this.autoTicker = autoTicker
    }
}

interface IAutoTickableBlockEntityType {
    boolean isAutoTickerEnabled()
    void setAutoTickerEnabled(boolean autoTicker)
}
