package io.tswf.minecraft.blockventure.core.transmutation.expansion

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.expansion.annotations.Expand
import net.minecraftforge.common.world.ModifiableBiomeInfo

@CompileStatic
@Expand(targets = @ClassReference(ModifiableBiomeInfo))
class ExpansionForgeModifiableBiomeInfo implements IRefreshableModifiableBiomeInfo {

    boolean refreshable

    @Override
    void setRefreshable(boolean isRefreshable) {
        refreshable = isRefreshable
    }

    @Override
    boolean isRefreshable() {
        return refreshable
    }
}

interface IRefreshableModifiableBiomeInfo {
    void setRefreshable(boolean isRefreshable)
    boolean isRefreshable()
}
