package io.tswf.minecraft.blockventure.core.transmutation.expansion

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.expansion.annotations.Expand
import net.minecraft.recipe.Ingredient

@Expand(targets = @ClassReference(Ingredient))
@CompileStatic
class ExpansionRecipeIngredient implements IMetadataSensitiveIngredient {
    boolean metadataSensitive

    boolean getMetadataSensitive() {
        return metadataSensitive
    }

    @Override
    boolean isMetadataSensitive() {
        return false
    }

    void setMetadataSensitive(boolean metadataSensitive) {
        this.metadataSensitive = metadataSensitive
    }
}

interface IMetadataSensitiveIngredient {
    boolean isMetadataSensitive()
    void setMetadataSensitive(boolean metadataSensitive)
}