package io.tswf.minecraft.blockventure.core.transmutation.expansion

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.expansion.annotations.Expand
import net.minecraft.world.biome.Biome

@Expand(targets = @ClassReference(Biome))
@CompileStatic
class ExpansionSingleEnrichBiome implements ISingleEnrichBiome {

    boolean singleEnrich
    boolean alreadyEnriched

    @Override
    boolean isSingleEnrich() {
        return singleEnrich
    }

    @Override
    void setSingleEnrich(boolean singleEnrich) {
        this.singleEnrich = singleEnrich
    }

    @Override
    boolean isAlreadyEnriched() {
        return alreadyEnriched
    }

    @Override
    void setAlreadyEnriched(boolean alreadyEnriched) {
        this.alreadyEnriched = alreadyEnriched
    }
}

interface ISingleEnrichBiome {
    boolean isSingleEnrich()
    void setSingleEnrich(boolean singleEnrich)

    boolean isAlreadyEnriched()
    void setAlreadyEnriched(boolean alreadyEnriched)
}