package io.tswf.minecraft.blockventure.core.transmutation.transmute

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.transmutation.expansion.IRefreshableModifiableBiomeInfo
import io.tswf.minecraft.blockventure.core.transmutation.view.ViewForgeModifiableBiomeInfo
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.common.annotation.MethodDescription
import io.tswf.transmutations.transmute.annotation.AtHead
import io.tswf.transmutations.transmute.annotation.Self
import io.tswf.transmutations.transmute.annotation.Transmute
import io.tswf.transmutations.transmute.meta.MissingTargetStrategy
import net.minecraft.registry.entry.RegistryEntry
import net.minecraftforge.common.world.ModifiableBiomeInfo

@CompileStatic
class TransmutationForgeModifiableBiomeInfo {

    @Transmute(
            targetClass = @ClassReference(ModifiableBiomeInfo),
            targetMethod = @MethodDescription(
                    name = "applyBiomeModifiers",
                    parameterTypeClasses = [ RegistryEntry, List ],
                    returnType = @ClassReference(ClassReference.VOID)
            ),
            onMissing = MissingTargetStrategy.THROW
    )
    @AtHead
    static void refreshModifiableInfo(
            RegistryEntry unused1,
            List unsused2,
            @Self ModifiableBiomeInfo modifiableBiomeInfo
    ) {
        def refreshableBiomeInfo = (IRefreshableModifiableBiomeInfo) modifiableBiomeInfo

        if (refreshableBiomeInfo.refreshable) {
            def viewModifiableBiomeInfo = (ViewForgeModifiableBiomeInfo) modifiableBiomeInfo

            if (modifiableBiomeInfo.modifiedBiomeInfo != null) {
                viewModifiableBiomeInfo.modifiedBiomeInfo = null
            }
        }
    }
}
