package io.tswf.minecraft.blockventure.core.transmutation.transmute

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.common.annotation.Constant
import io.tswf.transmutations.common.annotation.MethodDescription
import io.tswf.transmutations.transmute.annotation.AtHead
import io.tswf.transmutations.transmute.annotation.ReturningConstantIfTrue
import io.tswf.transmutations.transmute.annotation.ReturningVoidIfTrue
import io.tswf.transmutations.transmute.annotation.Transmute
import io.tswf.transmutations.transmute.meta.MissingTargetStrategy
import net.minecraftforge.registries.ForgeRegistry

@CompileStatic
class TransmutationLockedRegistries {

    @Transmute(
            targetClass = @ClassReference(descriptor = "Lnet/minecraftforge/registries/NamespacedWrapper;"),
            targetMethod = @MethodDescription(name = "lock", descriptor = "()V"),
            onMissing = MissingTargetStrategy.THROW
    )
    @AtHead
    @ReturningVoidIfTrue
    static boolean blockWrapperLock() {
        return true
    }

    @Transmute(
            targetClass = @ClassReference(ForgeRegistry),
            targetMethod = @MethodDescription(name = "isLocked", descriptor = "()Z"),
            onMissing = MissingTargetStrategy.THROW
    )
    @AtHead
    @ReturningConstantIfTrue(@Constant(booleanValue = false))
    static boolean passForgeRegistryLock() {
        return true
    }
}
