package io.tswf.minecraft.blockventure.core.transmutation.transmute


import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.transmutation.expansion.IMetadataSensitiveIngredient
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.common.annotation.Constant
import io.tswf.transmutations.common.annotation.MethodDescription
import io.tswf.transmutations.transmute.annotation.*
import io.tswf.transmutations.transmute.injection.points.MethodCallInsnType
import io.tswf.transmutations.transmute.meta.MissingTargetStrategy
import net.minecraft.item.Item
import net.minecraft.item.ItemStack
import net.minecraft.recipe.Ingredient

@CompileStatic
class TransmutationRecipeIngredient {

    @Transmute(
            targetClass = @ClassReference(Ingredient),
            targetMethod = @MethodDescription(name = "test", parameterTypeClasses = ItemStack, returnType = @ClassReference(descriptor = "Z")),
            onMissing = MissingTargetStrategy.THROW
    )
    @ReturningConstantIfTrue(@Constant(booleanValue = false))
    @AtMethodCall(
            owner = @ClassReference(ItemStack),
            method = @MethodDescription(name = "isOf", parameterTypeClasses = Item, returnType = @ClassReference(descriptor = "Z")),
            callType = MethodCallInsnType.VIRTUAL
    )
    static boolean test(
            ItemStack stackToCheck,

            @Self
            Ingredient self,

            @LocalVariableValue(index = 5, type = @ClassReference(ItemStack))
            ItemStack matchingStack
    ) {
        if (self instanceof IMetadataSensitiveIngredient) {
            if (self.metadataSensitive && matchingStack.damage != Short.MAX_VALUE && stackToCheck.damage != matchingStack.damage) {
                return true
            }

        }

        return false
    }

}
