package io.tswf.minecraft.blockventure.core.transmutation.view

import groovy.transform.CompileStatic
import io.tswf.transmutations.common.annotation.OnConflict
import io.tswf.transmutations.common.conflict.ConflictingMethodResolveStrategy
import io.tswf.transmutations.view.annotation.View
import net.minecraft.world.biome.BiomeEffects

@CompileStatic
@View(targetClasses = BiomeEffects)
interface ViewBiomeEffects {

    @OnConflict(ConflictingMethodResolveStrategy.WARN)
    void setFogColor(int fogColor)

    @OnConflict(ConflictingMethodResolveStrategy.WARN)
    void setWaterColor(int waterColor)

    @OnConflict(ConflictingMethodResolveStrategy.WARN)
    void setWaterFogColor(int waterFogColor)

    @OnConflict(ConflictingMethodResolveStrategy.WARN)
    void setSkyColor(int skyColor)

    @OnConflict(ConflictingMethodResolveStrategy.WARN)
    void setFoliageColor(Optional<Integer> foliageColor)

    @OnConflict(ConflictingMethodResolveStrategy.WARN)
    void setGrassColor(Optional<Integer> grassColor)
}