package io.tswf.minecraft.blockventure.core.util

import groovy.transform.CompileStatic
import net.minecraft.world.biome.source.util.MultiNoiseUtil

@CompileStatic
class ParameterRangePartitioner {

    static MultiNoiseUtil.ParameterRange getPartition(MultiNoiseUtil.ParameterRange old, int partitionsCount, int fromSeg = 0, int toSeg) {
        def partitions = getPartitions(old, partitionsCount)
        return new MultiNoiseUtil.ParameterRange(partitions.get(fromSeg).min(), partitions.get(toSeg).max())
    }

    static List<MultiNoiseUtil.ParameterRange> getPartitions(MultiNoiseUtil.ParameterRange old, int partitionsCount) {
        def result = new ArrayList<MultiNoiseUtil.ParameterRange>(partitionsCount)
        def step = (old.max() - old.min()) / partitionsCount
        def min = old.min()

        for (def partitionIndex = 0; partitionIndex < partitionsCount; partitionIndex ++) {
            def localMax = (min + step).longValue()
            result << new MultiNoiseUtil.ParameterRange(min, localMax)
            min = localMax
        }

        return result
    }

}
